/* DBusServer.c generated by valac 0.34.9, the Vala compiler
 * generated from DBusServer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <appstream.h>


#define TYPE_DBUS_SERVER (dbus_server_get_type ())
#define DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DBUS_SERVER, DBusServer))
#define DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DBUS_SERVER, DBusServerClass))
#define IS_DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DBUS_SERVER))
#define IS_DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DBUS_SERVER))
#define DBUS_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DBUS_SERVER, DBusServerClass))

typedef struct _DBusServer DBusServer;
typedef struct _DBusServerClass DBusServerClass;
typedef struct _DBusServerPrivate DBusServerPrivate;

#define APP_CENTER_CORE_TYPE_CLIENT (app_center_core_client_get_type ())
#define APP_CENTER_CORE_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_CLIENT, AppCenterCoreClient))
#define APP_CENTER_CORE_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_CLIENT, AppCenterCoreClientClass))
#define APP_CENTER_CORE_IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_CLIENT))
#define APP_CENTER_CORE_IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_CLIENT))
#define APP_CENTER_CORE_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_CLIENT, AppCenterCoreClientClass))

typedef struct _AppCenterCoreClient AppCenterCoreClient;
typedef struct _AppCenterCoreClientClass AppCenterCoreClientClass;
typedef struct _Block38Data Block38Data;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define APP_CENTER_CORE_TYPE_PACKAGE (app_center_core_package_get_type ())
#define APP_CENTER_CORE_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackage))
#define APP_CENTER_CORE_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackageClass))
#define APP_CENTER_CORE_IS_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_PACKAGE))
#define APP_CENTER_CORE_IS_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_PACKAGE))
#define APP_CENTER_CORE_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackageClass))

typedef struct _AppCenterCorePackage AppCenterCorePackage;
typedef struct _AppCenterCorePackageClass AppCenterCorePackageClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DBusServer {
	GObject parent_instance;
	DBusServerPrivate * priv;
};

struct _DBusServerClass {
	GObjectClass parent_class;
};

struct _Block38Data {
	int _ref_count_;
	AppCenterCoreClient* client;
	GMainLoop* loop;
};


static gpointer dbus_server_parent_class = NULL;
static GOnce dbus_server_instance;
static GOnce dbus_server_instance = G_ONCE_INIT;

GType dbus_server_get_type (void) G_GNUC_CONST;
guint dbus_server_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
enum  {
	DBUS_SERVER_DUMMY_PROPERTY
};
DBusServer* dbus_server_get_default (void);
static DBusServer* __lambda124_ (void);
static DBusServer* dbus_server_new (void);
static DBusServer* dbus_server_construct (GType object_type);
static gpointer ___lambda124__gthread_func (gpointer self);
void dbus_server_init (void);
GType app_center_core_client_get_type (void) G_GNUC_CONST;
static Block38Data* block38_data_ref (Block38Data* _data38_);
static void block38_data_unref (void * _userdata_);
AppCenterCoreClient* app_center_core_client_get_default (void);
void app_center_core_client_get_installed_applications (AppCenterCoreClient* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
GType app_center_core_package_get_type (void) G_GNUC_CONST;
GeeCollection* app_center_core_client_get_installed_applications_finish (AppCenterCoreClient* self, GAsyncResult* _res_);
static void __lambda125_ (Block38Data* _data38_, GObject* obj, GAsyncResult* res);
static void ___lambda125__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
void dbus_server_install (DBusServer* self, const gchar* component_id, GError** error);
AppCenterCorePackage* app_center_core_client_get_package_for_component_id (AppCenterCoreClient* self, const gchar* id);
void app_center_core_package_install (AppCenterCorePackage* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean app_center_core_package_install_finish (AppCenterCorePackage* self, GAsyncResult* _res_);
void dbus_server_uninstall (DBusServer* self, const gchar* component_id, GError** error);
void app_center_core_package_uninstall (AppCenterCorePackage* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean app_center_core_package_uninstall_finish (AppCenterCorePackage* self, GAsyncResult* _res_);
void dbus_server_update (DBusServer* self, const gchar* component_id, GError** error);
void app_center_core_package_update (AppCenterCorePackage* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean app_center_core_package_update_finish (AppCenterCorePackage* self, GAsyncResult* _res_);
gchar* dbus_server_get_component_from_desktop_id (DBusServer* self, const gchar* desktop_id);
AppCenterCorePackage* app_center_core_client_get_package_for_desktop_id (AppCenterCoreClient* self, const gchar* desktop_id);
AsComponent* app_center_core_package_get_component (AppCenterCorePackage* self);
gchar** dbus_server_search_components (DBusServer* self, const gchar* query, int* result_length1);
GeeCollection* app_center_core_client_search_applications (AppCenterCoreClient* self, const gchar* query, AsCategory* category);
static void _vala_array_add14 (gchar*** array, int* length, int* size, gchar* value);
static void dbus_server_finalize (GObject* obj);
static void _dbus_dbus_server_install (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_dbus_server_uninstall (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_dbus_server_update (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_dbus_server_get_component_from_desktop_id (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_dbus_server_search_components (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void dbus_server_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* dbus_server_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean dbus_server_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_server_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo _dbus_server_dbus_arg_info_install_component_id = {-1, "component_id", "s"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_install_in[] = {&_dbus_server_dbus_arg_info_install_component_id, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_install_out[] = {NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_install = {-1, "Install", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_install_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_install_out)};
static const GDBusArgInfo _dbus_server_dbus_arg_info_uninstall_component_id = {-1, "component_id", "s"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_uninstall_in[] = {&_dbus_server_dbus_arg_info_uninstall_component_id, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_uninstall_out[] = {NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_uninstall = {-1, "Uninstall", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_uninstall_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_uninstall_out)};
static const GDBusArgInfo _dbus_server_dbus_arg_info_update_component_id = {-1, "component_id", "s"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_update_in[] = {&_dbus_server_dbus_arg_info_update_component_id, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_update_out[] = {NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_update = {-1, "Update", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_update_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_update_out)};
static const GDBusArgInfo _dbus_server_dbus_arg_info_get_component_from_desktop_id_desktop_id = {-1, "desktop_id", "s"};
static const GDBusArgInfo _dbus_server_dbus_arg_info_get_component_from_desktop_id_result = {-1, "result", "s"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_get_component_from_desktop_id_in[] = {&_dbus_server_dbus_arg_info_get_component_from_desktop_id_desktop_id, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_get_component_from_desktop_id_out[] = {&_dbus_server_dbus_arg_info_get_component_from_desktop_id_result, NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_get_component_from_desktop_id = {-1, "GetComponentFromDesktopId", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_get_component_from_desktop_id_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_get_component_from_desktop_id_out)};
static const GDBusArgInfo _dbus_server_dbus_arg_info_search_components_query = {-1, "query", "s"};
static const GDBusArgInfo _dbus_server_dbus_arg_info_search_components_result = {-1, "result", "as"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_search_components_in[] = {&_dbus_server_dbus_arg_info_search_components_query, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_search_components_out[] = {&_dbus_server_dbus_arg_info_search_components_result, NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_search_components = {-1, "SearchComponents", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_search_components_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_search_components_out)};
static const GDBusMethodInfo * const _dbus_server_dbus_method_info[] = {&_dbus_server_dbus_method_info_install, &_dbus_server_dbus_method_info_uninstall, &_dbus_server_dbus_method_info_update, &_dbus_server_dbus_method_info_get_component_from_desktop_id, &_dbus_server_dbus_method_info_search_components, NULL};
static const GDBusSignalInfo * const _dbus_server_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _dbus_server_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _dbus_server_dbus_interface_info = {-1, "io.elementary.appcenter", (GDBusMethodInfo **) (&_dbus_server_dbus_method_info), (GDBusSignalInfo **) (&_dbus_server_dbus_signal_info), (GDBusPropertyInfo **) (&_dbus_server_dbus_property_info)};
static const GDBusInterfaceVTable _dbus_server_dbus_interface_vtable = {dbus_server_dbus_interface_method_call, dbus_server_dbus_interface_get_property, dbus_server_dbus_interface_set_property};

static DBusServer* __lambda124_ (void) {
	DBusServer* result = NULL;
	DBusServer* _tmp0_ = NULL;
#line 25 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp0_ = dbus_server_new ();
#line 25 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	result = _tmp0_;
#line 25 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	return result;
#line 175 "DBusServer.c"
}


static gpointer ___lambda124__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda124_ ();
#line 25 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	return result;
#line 184 "DBusServer.c"
}


DBusServer* dbus_server_get_default (void) {
	DBusServer* result = NULL;
	gconstpointer _tmp0_ = NULL;
#line 25 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp0_ = g_once (&dbus_server_instance, ___lambda124__gthread_func, NULL);
#line 25 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	result = (DBusServer*) _tmp0_;
#line 25 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	return result;
#line 197 "DBusServer.c"
}


static Block38Data* block38_data_ref (Block38Data* _data38_) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_atomic_int_inc (&_data38_->_ref_count_);
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	return _data38_;
#line 206 "DBusServer.c"
}


static void block38_data_unref (void * _userdata_) {
	Block38Data* _data38_;
	_data38_ = (Block38Data*) _userdata_;
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	if (g_atomic_int_dec_and_test (&_data38_->_ref_count_)) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_main_loop_unref0 (_data38_->loop);
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (_data38_->client);
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		g_slice_free (Block38Data, _data38_);
#line 221 "DBusServer.c"
	}
}


static gpointer _g_object_ref0 (gpointer self) {
#line 29 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	return self ? g_object_ref (self) : NULL;
#line 229 "DBusServer.c"
}


static void __lambda125_ (Block38Data* _data38_, GObject* obj, GAsyncResult* res) {
	GAsyncResult* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* _tmp2_ = NULL;
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_if_fail (res != NULL);
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp0_ = res;
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp1_ = app_center_core_client_get_installed_applications_finish (_data38_->client, _tmp0_);
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp2_ = _tmp1_;
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (_tmp2_);
#line 34 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_main_loop_quit (_data38_->loop);
#line 249 "DBusServer.c"
}


static void ___lambda125__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	__lambda125_ (self, source_object, res);
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	block38_data_unref (self);
#line 258 "DBusServer.c"
}


void dbus_server_init (void) {
	Block38Data* _data38_;
	AppCenterCoreClient* _tmp0_ = NULL;
	AppCenterCoreClient* _tmp1_ = NULL;
	GMainLoop* _tmp2_ = NULL;
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_data38_ = g_slice_new0 (Block38Data);
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_data38_->_ref_count_ = 1;
#line 29 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 29 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 29 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_data38_->client = _tmp1_;
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp2_ = g_main_loop_new (NULL, FALSE);
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_data38_->loop = _tmp2_;
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	app_center_core_client_get_installed_applications (_data38_->client, ___lambda125__gasync_ready_callback, block38_data_ref (_data38_));
#line 37 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_main_loop_run (_data38_->loop);
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	block38_data_unref (_data38_);
#line 28 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_data38_ = NULL;
#line 289 "DBusServer.c"
}


static DBusServer* dbus_server_construct (GType object_type) {
	DBusServer * self = NULL;
#line 40 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	self = (DBusServer*) g_object_new (object_type, NULL);
#line 40 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	return self;
#line 299 "DBusServer.c"
}


static DBusServer* dbus_server_new (void) {
#line 40 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	return dbus_server_construct (TYPE_DBUS_SERVER);
#line 306 "DBusServer.c"
}


/**
     * Installs a package that's id is component_id and also
     * sends a notification when installation finishes or shows
     * a dialog when installation fails
     *
     * @param compontent_id  the component ID to install
     */
void dbus_server_install (DBusServer* self, const gchar* component_id, GError** error) {
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_ = NULL;
	AppCenterCoreClient* _tmp1_ = NULL;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreClient* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	AppCenterCorePackage* _tmp4_ = NULL;
	AppCenterCorePackage* _tmp5_ = NULL;
	AppCenterCorePackage* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
#line 51 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_if_fail (self != NULL);
#line 51 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_if_fail (component_id != NULL);
#line 52 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 52 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 52 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 53 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 53 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp3_ = component_id;
#line 53 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_get_package_for_component_id (_tmp2_, _tmp3_);
#line 53 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	package = _tmp4_;
#line 54 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp5_ = package;
#line 54 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	if (_tmp5_ == NULL) {
#line 350 "DBusServer.c"
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp6_ = component_id;
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp7_ = g_strdup_printf ("Failed to find package for '%s' component ID", _tmp6_);
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp8_ = _tmp7_;
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp9_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp8_);
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp10_ = _tmp9_;
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_free0 (_tmp8_);
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_inner_error_ = _tmp10_;
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		g_propagate_error (error, _inner_error_);
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (package);
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (client);
#line 55 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		return;
#line 378 "DBusServer.c"
	}
#line 58 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp11_ = package;
#line 58 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	app_center_core_package_install (_tmp11_, NULL, NULL);
#line 51 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (package);
#line 51 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 388 "DBusServer.c"
}


/**
     * Uninstalls a package that's id is component_id
     *
     * @param compontent_id  the component ID to uninstall
     */
void dbus_server_uninstall (DBusServer* self, const gchar* component_id, GError** error) {
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_ = NULL;
	AppCenterCoreClient* _tmp1_ = NULL;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreClient* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	AppCenterCorePackage* _tmp4_ = NULL;
	AppCenterCorePackage* _tmp5_ = NULL;
	AppCenterCorePackage* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
#line 66 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_if_fail (self != NULL);
#line 66 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_if_fail (component_id != NULL);
#line 67 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 67 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 67 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 68 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 68 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp3_ = component_id;
#line 68 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_get_package_for_component_id (_tmp2_, _tmp3_);
#line 68 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	package = _tmp4_;
#line 69 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp5_ = package;
#line 69 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	if (_tmp5_ == NULL) {
#line 430 "DBusServer.c"
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp6_ = component_id;
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp7_ = g_strdup_printf ("Failed to find package for '%s' component ID", _tmp6_);
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp8_ = _tmp7_;
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp9_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp8_);
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp10_ = _tmp9_;
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_free0 (_tmp8_);
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_inner_error_ = _tmp10_;
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		g_propagate_error (error, _inner_error_);
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (package);
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (client);
#line 70 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		return;
#line 458 "DBusServer.c"
	}
#line 73 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp11_ = package;
#line 73 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	app_center_core_package_uninstall (_tmp11_, NULL, NULL);
#line 66 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (package);
#line 66 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 468 "DBusServer.c"
}


/**
     * Updates a package that's id is component_id
     *
     * @param compontent_id  the component ID to update
     */
void dbus_server_update (DBusServer* self, const gchar* component_id, GError** error) {
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_ = NULL;
	AppCenterCoreClient* _tmp1_ = NULL;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreClient* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	AppCenterCorePackage* _tmp4_ = NULL;
	AppCenterCorePackage* _tmp5_ = NULL;
	AppCenterCorePackage* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
#line 81 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_if_fail (self != NULL);
#line 81 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_if_fail (component_id != NULL);
#line 82 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 82 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 82 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 83 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 83 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp3_ = component_id;
#line 83 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_get_package_for_component_id (_tmp2_, _tmp3_);
#line 83 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	package = _tmp4_;
#line 84 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp5_ = package;
#line 84 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	if (_tmp5_ == NULL) {
#line 510 "DBusServer.c"
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp6_ = component_id;
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp7_ = g_strdup_printf ("Failed to find package for '%s' component ID", _tmp6_);
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp8_ = _tmp7_;
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp9_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp8_);
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp10_ = _tmp9_;
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_free0 (_tmp8_);
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_inner_error_ = _tmp10_;
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		g_propagate_error (error, _inner_error_);
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (package);
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (client);
#line 85 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		return;
#line 538 "DBusServer.c"
	}
#line 88 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp11_ = package;
#line 88 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	app_center_core_package_update (_tmp11_, NULL, NULL);
#line 81 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (package);
#line 81 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 548 "DBusServer.c"
}


/**
     * Gets the component ID for the specified desktop ID
     *
     * @param desktop_id  the desktop ID (must include ".desktop" extension)
     * @return the component ID, if not found returns empty string
     */
gchar* dbus_server_get_component_from_desktop_id (DBusServer* self, const gchar* desktop_id) {
	gchar* result = NULL;
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_ = NULL;
	AppCenterCoreClient* _tmp1_ = NULL;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreClient* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	AppCenterCorePackage* _tmp4_ = NULL;
	AppCenterCorePackage* _tmp5_ = NULL;
	gchar* _tmp11_ = NULL;
#line 97 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_val_if_fail (desktop_id != NULL, NULL);
#line 98 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 98 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 98 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 99 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 99 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp3_ = desktop_id;
#line 99 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_get_package_for_desktop_id (_tmp2_, _tmp3_);
#line 99 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	package = _tmp4_;
#line 100 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp5_ = package;
#line 100 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	if (_tmp5_ != NULL) {
#line 591 "DBusServer.c"
		AppCenterCorePackage* _tmp6_ = NULL;
		AsComponent* _tmp7_ = NULL;
		AsComponent* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
#line 101 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp6_ = package;
#line 101 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp7_ = app_center_core_package_get_component (_tmp6_);
#line 101 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp8_ = _tmp7_;
#line 101 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp9_ = as_component_get_id (_tmp8_);
#line 101 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 101 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		result = _tmp10_;
#line 101 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (package);
#line 101 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (client);
#line 101 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		return result;
#line 615 "DBusServer.c"
	}
#line 104 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp11_ = g_strdup ("");
#line 104 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	result = _tmp11_;
#line 104 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (package);
#line 104 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 104 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	return result;
#line 627 "DBusServer.c"
}


/**
     * Searches for a query in the AppStream database
     *
     * @param query  the query to search for
     * @return a list of component ID's that match the query
     */
static void _vala_array_add14 (gchar*** array, int* length, int* size, gchar* value) {
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	if ((*length) == (*size)) {
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 644 "DBusServer.c"
	}
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	(*array)[(*length)++] = value;
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	(*array)[*length] = NULL;
#line 650 "DBusServer.c"
}


gchar** dbus_server_search_components (DBusServer* self, const gchar* query, int* result_length1) {
	gchar** result = NULL;
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_ = NULL;
	AppCenterCoreClient* _tmp1_ = NULL;
	GeeCollection* packages = NULL;
	AppCenterCoreClient* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GeeCollection* _tmp4_ = NULL;
	gchar** components = NULL;
	gchar** _tmp5_ = NULL;
	gint components_length1 = 0;
	gint _components_size_ = 0;
	gchar** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
#line 113 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 114 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 114 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 114 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 115 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 115 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp3_ = query;
#line 115 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_search_applications (_tmp2_, _tmp3_, NULL);
#line 115 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	packages = _tmp4_;
#line 116 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp5_ = g_new0 (gchar*, 0 + 1);
#line 116 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	components = _tmp5_;
#line 116 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	components_length1 = 0;
#line 116 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_components_size_ = components_length1;
#line 695 "DBusServer.c"
	{
		GeeIterator* _package_it = NULL;
		GeeCollection* _tmp6_ = NULL;
		GeeIterator* _tmp7_ = NULL;
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp6_ = packages;
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_package_it = _tmp7_;
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		while (TRUE) {
#line 708 "DBusServer.c"
			GeeIterator* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			AppCenterCorePackage* package = NULL;
			GeeIterator* _tmp10_ = NULL;
			gpointer _tmp11_ = NULL;
			gchar** _tmp12_ = NULL;
			gint _tmp12__length1 = 0;
			AppCenterCorePackage* _tmp13_ = NULL;
			AsComponent* _tmp14_ = NULL;
			AsComponent* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp8_ = _package_it;
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			if (!_tmp9_) {
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
				break;
#line 729 "DBusServer.c"
			}
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp10_ = _package_it;
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			package = (AppCenterCorePackage*) _tmp11_;
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp12_ = components;
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp12__length1 = components_length1;
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp13_ = package;
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp14_ = app_center_core_package_get_component (_tmp13_);
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp15_ = _tmp14_;
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp16_ = as_component_get_id (_tmp15_);
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 118 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_vala_array_add14 (&components, &components_length1, &_components_size_, _tmp17_);
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
			_g_object_unref0 (package);
#line 755 "DBusServer.c"
		}
#line 117 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		_g_object_unref0 (_package_it);
#line 759 "DBusServer.c"
	}
#line 121 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp18_ = components;
#line 121 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_tmp18__length1 = components_length1;
#line 121 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	if (result_length1) {
#line 121 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
		*result_length1 = _tmp18__length1;
#line 769 "DBusServer.c"
	}
#line 121 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	result = _tmp18_;
#line 121 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (packages);
#line 121 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 121 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	return result;
#line 779 "DBusServer.c"
}


static void dbus_server_class_init (DBusServerClass * klass) {
#line 22 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	dbus_server_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	G_OBJECT_CLASS (klass)->finalize = dbus_server_finalize;
#line 788 "DBusServer.c"
}


static void dbus_server_instance_init (DBusServer * self) {
}


static void dbus_server_finalize (GObject* obj) {
	DBusServer * self;
#line 22 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DBUS_SERVER, DBusServer);
#line 22 "/builddir/build/BUILD/appcenter-0.2.7/src/Services/DBusServer.vala"
	G_OBJECT_CLASS (dbus_server_parent_class)->finalize (obj);
#line 802 "DBusServer.c"
}


GType dbus_server_get_type (void) {
	static volatile gsize dbus_server_type_id__volatile = 0;
	if (g_once_init_enter (&dbus_server_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DBusServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dbus_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DBusServer), 0, (GInstanceInitFunc) dbus_server_instance_init, NULL };
		GType dbus_server_type_id;
		dbus_server_type_id = g_type_register_static (G_TYPE_OBJECT, "DBusServer", &g_define_type_info, 0);
		g_type_set_qdata (dbus_server_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) dbus_server_register_object);
		g_once_init_leave (&dbus_server_type_id__volatile, dbus_server_type_id);
	}
	return dbus_server_type_id__volatile;
}


static void _dbus_dbus_server_install (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* component_id = NULL;
	GVariant* _tmp9_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	component_id = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	dbus_server_install (self, component_id, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (component_id);
}


static void _dbus_dbus_server_uninstall (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* component_id = NULL;
	GVariant* _tmp10_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp10_ = g_variant_iter_next_value (&_arguments_iter);
	component_id = g_variant_dup_string (_tmp10_, NULL);
	g_variant_unref (_tmp10_);
	dbus_server_uninstall (self, component_id, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (component_id);
}


static void _dbus_dbus_server_update (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* component_id = NULL;
	GVariant* _tmp11_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	component_id = g_variant_dup_string (_tmp11_, NULL);
	g_variant_unref (_tmp11_);
	dbus_server_update (self, component_id, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (component_id);
}


static void _dbus_dbus_server_get_component_from_desktop_id (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* desktop_id = NULL;
	GVariant* _tmp12_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp12_ = g_variant_iter_next_value (&_arguments_iter);
	desktop_id = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	result = dbus_server_get_component_from_desktop_id (self, desktop_id);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (desktop_id);
}


static void _dbus_dbus_server_search_components (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* query = NULL;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	int result_length1 = 0;
	gchar** _tmp14_;
	GVariantBuilder _tmp15_;
	int _tmp16_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	query = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	result = dbus_server_search_components (self, query, &result_length1);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp14_ = result;
	g_variant_builder_init (&_tmp15_, G_VARIANT_TYPE ("as"));
	for (_tmp16_ = 0; _tmp16_ < result_length1; _tmp16_++) {
		g_variant_builder_add_value (&_tmp15_, g_variant_new_string (*_tmp14_));
		_tmp14_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp15_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (query);
}


static void dbus_server_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Install") == 0) {
		_dbus_dbus_server_install (object, parameters, invocation);
	} else if (strcmp (method_name, "Uninstall") == 0) {
		_dbus_dbus_server_uninstall (object, parameters, invocation);
	} else if (strcmp (method_name, "Update") == 0) {
		_dbus_dbus_server_update (object, parameters, invocation);
	} else if (strcmp (method_name, "GetComponentFromDesktopId") == 0) {
		_dbus_dbus_server_get_component_from_desktop_id (object, parameters, invocation);
	} else if (strcmp (method_name, "SearchComponents") == 0) {
		_dbus_dbus_server_search_components (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* dbus_server_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean dbus_server_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint dbus_server_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_dbus_server_dbus_interface_info), &_dbus_server_dbus_interface_vtable, data, _dbus_server_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _dbus_server_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



