/* Settings.c generated by valac 0.34.9, the Vala compiler
 * generated from Settings.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
* Copyright (c) 2012-2017 elementary LLC (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Corentin Noël <corentin@elementary.io>
*/

#include <glib.h>
#include <glib-object.h>
#include <granite.h>


#define APP_CENTER_TYPE_SETTINGS (app_center_settings_get_type ())
#define APP_CENTER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_TYPE_SETTINGS, AppCenterSettings))
#define APP_CENTER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_TYPE_SETTINGS, AppCenterSettingsClass))
#define APP_CENTER_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_TYPE_SETTINGS))
#define APP_CENTER_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_TYPE_SETTINGS))
#define APP_CENTER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_TYPE_SETTINGS, AppCenterSettingsClass))

typedef struct _AppCenterSettings AppCenterSettings;
typedef struct _AppCenterSettingsClass AppCenterSettingsClass;
typedef struct _AppCenterSettingsPrivate AppCenterSettingsPrivate;

#define APP_CENTER_SETTINGS_TYPE_WINDOW_STATE (app_center_settings_window_state_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AppCenterSettings {
	GraniteServicesSettings parent_instance;
	AppCenterSettingsPrivate * priv;
};

struct _AppCenterSettingsClass {
	GraniteServicesSettingsClass parent_class;
};

typedef enum  {
	APP_CENTER_SETTINGS_WINDOW_STATE_NORMAL,
	APP_CENTER_SETTINGS_WINDOW_STATE_MAXIMIZED,
	APP_CENTER_SETTINGS_WINDOW_STATE_FULLSCREEN
} AppCenterSettingsWindowState;

struct _AppCenterSettingsPrivate {
	gint _window_width;
	gint _window_height;
	AppCenterSettingsWindowState _window_state;
	gboolean _developer_mode;
};


static gpointer app_center_settings_parent_class = NULL;
static AppCenterSettings* app_center_settings_main_settings;
static AppCenterSettings* app_center_settings_main_settings = NULL;

GType app_center_settings_get_type (void) G_GNUC_CONST;
GType app_center_settings_window_state_get_type (void) G_GNUC_CONST;
#define APP_CENTER_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), APP_CENTER_TYPE_SETTINGS, AppCenterSettingsPrivate))
enum  {
	APP_CENTER_SETTINGS_DUMMY_PROPERTY,
	APP_CENTER_SETTINGS_WINDOW_WIDTH,
	APP_CENTER_SETTINGS_WINDOW_HEIGHT,
	APP_CENTER_SETTINGS_WINDOW_STATE,
	APP_CENTER_SETTINGS_DEVELOPER_MODE
};
AppCenterSettings* app_center_settings_get_default (void);
static AppCenterSettings* app_center_settings_new (void);
static AppCenterSettings* app_center_settings_construct (GType object_type);
gint app_center_settings_get_window_width (AppCenterSettings* self);
void app_center_settings_set_window_width (AppCenterSettings* self, gint value);
gint app_center_settings_get_window_height (AppCenterSettings* self);
void app_center_settings_set_window_height (AppCenterSettings* self, gint value);
AppCenterSettingsWindowState app_center_settings_get_window_state (AppCenterSettings* self);
void app_center_settings_set_window_state (AppCenterSettings* self, AppCenterSettingsWindowState value);
gboolean app_center_settings_get_developer_mode (AppCenterSettings* self);
void app_center_settings_set_developer_mode (AppCenterSettings* self, gboolean value);
static void app_center_settings_finalize (GObject* obj);
static void _vala_app_center_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_app_center_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType app_center_settings_window_state_get_type (void) {
	static volatile gsize app_center_settings_window_state_type_id__volatile = 0;
	if (g_once_init_enter (&app_center_settings_window_state_type_id__volatile)) {
		static const GEnumValue values[] = {{APP_CENTER_SETTINGS_WINDOW_STATE_NORMAL, "APP_CENTER_SETTINGS_WINDOW_STATE_NORMAL", "normal"}, {APP_CENTER_SETTINGS_WINDOW_STATE_MAXIMIZED, "APP_CENTER_SETTINGS_WINDOW_STATE_MAXIMIZED", "maximized"}, {APP_CENTER_SETTINGS_WINDOW_STATE_FULLSCREEN, "APP_CENTER_SETTINGS_WINDOW_STATE_FULLSCREEN", "fullscreen"}, {0, NULL, NULL}};
		GType app_center_settings_window_state_type_id;
		app_center_settings_window_state_type_id = g_enum_register_static ("AppCenterSettingsWindowState", values);
		g_once_init_leave (&app_center_settings_window_state_type_id__volatile, app_center_settings_window_state_type_id);
	}
	return app_center_settings_window_state_type_id__volatile;
}


AppCenterSettings* app_center_settings_get_default (void) {
	AppCenterSettings* result = NULL;
	AppCenterSettings* _tmp0_ = NULL;
	AppCenterSettings* _tmp2_ = NULL;
#line 37 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp0_ = app_center_settings_main_settings;
#line 37 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	if (_tmp0_ == NULL) {
#line 119 "Settings.c"
		AppCenterSettings* _tmp1_ = NULL;
#line 38 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		_tmp1_ = app_center_settings_new ();
#line 38 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		_g_object_unref0 (app_center_settings_main_settings);
#line 38 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		app_center_settings_main_settings = _tmp1_;
#line 127 "Settings.c"
	}
#line 39 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp2_ = app_center_settings_main_settings;
#line 39 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	result = _tmp2_;
#line 39 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	return result;
#line 135 "Settings.c"
}


static AppCenterSettings* app_center_settings_construct (GType object_type) {
	AppCenterSettings * self = NULL;
#line 43 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	self = (AppCenterSettings*) granite_services_settings_construct (object_type, "io.elementary.appcenter.settings");
#line 42 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	return self;
#line 145 "Settings.c"
}


static AppCenterSettings* app_center_settings_new (void) {
#line 42 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	return app_center_settings_construct (APP_CENTER_TYPE_SETTINGS);
#line 152 "Settings.c"
}


gint app_center_settings_get_window_width (AppCenterSettings* self) {
	gint result;
	gint _tmp0_ = 0;
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp0_ = self->priv->_window_width;
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	return result;
#line 167 "Settings.c"
}


void app_center_settings_set_window_width (AppCenterSettings* self, gint value) {
	gint _tmp0_ = 0;
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp0_ = value;
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	self->priv->_window_width = _tmp0_;
#line 30 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_object_notify ((GObject *) self, "window-width");
#line 181 "Settings.c"
}


gint app_center_settings_get_window_height (AppCenterSettings* self) {
	gint result;
	gint _tmp0_ = 0;
#line 31 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 31 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp0_ = self->priv->_window_height;
#line 31 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	return result;
#line 196 "Settings.c"
}


void app_center_settings_set_window_height (AppCenterSettings* self, gint value) {
	gint _tmp0_ = 0;
#line 31 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp0_ = value;
#line 31 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	self->priv->_window_height = _tmp0_;
#line 31 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_object_notify ((GObject *) self, "window-height");
#line 210 "Settings.c"
}


AppCenterSettingsWindowState app_center_settings_get_window_state (AppCenterSettings* self) {
	AppCenterSettingsWindowState result;
	AppCenterSettingsWindowState _tmp0_ = 0;
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp0_ = self->priv->_window_state;
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	return result;
#line 225 "Settings.c"
}


void app_center_settings_set_window_state (AppCenterSettings* self, AppCenterSettingsWindowState value) {
	AppCenterSettingsWindowState _tmp0_ = 0;
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp0_ = value;
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	self->priv->_window_state = _tmp0_;
#line 32 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_object_notify ((GObject *) self, "window-state");
#line 239 "Settings.c"
}


gboolean app_center_settings_get_developer_mode (AppCenterSettings* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp0_ = self->priv->_developer_mode;
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	return result;
#line 254 "Settings.c"
}


void app_center_settings_set_developer_mode (AppCenterSettings* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	_tmp0_ = value;
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	self->priv->_developer_mode = _tmp0_;
#line 33 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_object_notify ((GObject *) self, "developer-mode");
#line 268 "Settings.c"
}


static void app_center_settings_class_init (AppCenterSettingsClass * klass) {
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	app_center_settings_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_type_class_add_private (klass, sizeof (AppCenterSettingsPrivate));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_app_center_settings_get_property;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_app_center_settings_set_property;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = app_center_settings_finalize;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_WIDTH, g_param_spec_int ("window-width", "window-width", "window-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_HEIGHT, g_param_spec_int ("window-height", "window-height", "window-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_STATE, g_param_spec_enum ("window-state", "window-state", "window-state", APP_CENTER_SETTINGS_TYPE_WINDOW_STATE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_DEVELOPER_MODE, g_param_spec_boolean ("developer-mode", "developer-mode", "developer-mode", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 291 "Settings.c"
}


static void app_center_settings_instance_init (AppCenterSettings * self) {
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	self->priv = APP_CENTER_SETTINGS_GET_PRIVATE (self);
#line 298 "Settings.c"
}


static void app_center_settings_finalize (GObject* obj) {
	AppCenterSettings * self;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_CENTER_TYPE_SETTINGS, AppCenterSettings);
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	G_OBJECT_CLASS (app_center_settings_parent_class)->finalize (obj);
#line 308 "Settings.c"
}


GType app_center_settings_get_type (void) {
	static volatile gsize app_center_settings_type_id__volatile = 0;
	if (g_once_init_enter (&app_center_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppCenterSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_center_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppCenterSettings), 0, (GInstanceInitFunc) app_center_settings_instance_init, NULL };
		GType app_center_settings_type_id;
		app_center_settings_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "AppCenterSettings", &g_define_type_info, 0);
		g_once_init_leave (&app_center_settings_type_id__volatile, app_center_settings_type_id);
	}
	return app_center_settings_type_id__volatile;
}


static void _vala_app_center_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AppCenterSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_TYPE_SETTINGS, AppCenterSettings);
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_WIDTH:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		g_value_set_int (value, app_center_settings_get_window_width (self));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_HEIGHT:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		g_value_set_int (value, app_center_settings_get_window_height (self));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_STATE:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		g_value_set_enum (value, app_center_settings_get_window_state (self));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		case APP_CENTER_SETTINGS_DEVELOPER_MODE:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		g_value_set_boolean (value, app_center_settings_get_developer_mode (self));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 353 "Settings.c"
		default:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 359 "Settings.c"
	}
}


static void _vala_app_center_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	AppCenterSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_TYPE_SETTINGS, AppCenterSettings);
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_WIDTH:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		app_center_settings_set_window_width (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_HEIGHT:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		app_center_settings_set_window_height (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_STATE:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		app_center_settings_set_window_state (self, g_value_get_enum (value));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		case APP_CENTER_SETTINGS_DEVELOPER_MODE:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		app_center_settings_set_developer_mode (self, g_value_get_boolean (value));
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 393 "Settings.c"
		default:
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/appcenter-0.2.7/src/Settings.vala"
		break;
#line 399 "Settings.c"
	}
}



